/*
 * common.c
 *
 *  Created on: 05.08.2018
 *      Author: marek
 */

#include <time.h>
#include "common.h"
#include "dcf77.h"
#include "main.h"
#include "stm32l0xx_hal.h"

extern RTC_HandleTypeDef hrtc;

uint8_t rtcTickFlag = 0;
uint32_t uptime = 0;

void setRealTimeClock (time_t tm) {
	RTC_TimeTypeDef timeStruct;
	RTC_DateTypeDef dateStruct;
	struct tm *dstTime;

	dstTime = gmtime(&tm);
	timeStruct.Hours = dstTime->tm_hour;
	timeStruct.Minutes = dstTime->tm_min;
	timeStruct.Seconds = dstTime->tm_sec;
	dateStruct.Year = (dstTime->tm_year)-100;
	dateStruct.Month = (dstTime->tm_mon)+1;
	dateStruct.Date = dstTime->tm_mday;
	HAL_RTC_SetTime(&hrtc, &timeStruct, RTC_FORMAT_BIN);
	HAL_RTC_SetDate(&hrtc, &dateStruct, RTC_FORMAT_BIN);
}


time_t time (time_t * timer) {
	RTC_TimeTypeDef timeStruct;
	RTC_DateTypeDef dateStruct;
	struct tm dstTime;
	HAL_RTC_GetTime(&hrtc, &timeStruct, RTC_FORMAT_BIN);
	HAL_RTC_GetDate(&hrtc, &dateStruct, RTC_FORMAT_BIN);
	dstTime.tm_hour = timeStruct.Hours;
	dstTime.tm_min = timeStruct.Minutes;
	dstTime.tm_sec = timeStruct.Seconds;
	dstTime.tm_year = dateStruct.Year + 100;
	dstTime.tm_mon = dateStruct.Month - 1;
	dstTime.tm_mday = dateStruct.Date;
	return mktime(&dstTime);
}


void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin) {
	if (GPIO_Pin == DCF77_IN_Pin) {
		DCF77_intHandler();
		HAL_GPIO_TogglePin(LD3_GPIO_Port, LD3_Pin);
	}
}


void HAL_RTC_AlarmAEventCallback(RTC_HandleTypeDef *hrtc) {
	rtcTickFlag = 1;
	uptime++;
}
